
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   07:25:00 05/01/2007
-- Design Name:   dcc
-- Module Name:   C:/iseproj/dcc/dcc_tb.vhd
-- Project Name:  dccv2c0b
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: dcc
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library ieee,mylib;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use mylib.vtx_pack.all;
use mylib.dcc_pack.all;

ENTITY dcc_tb_vhd IS
END dcc_tb_vhd;

ARCHITECTURE behavior OF dcc_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT dcc
	PORT(
		reset_dll : IN std_logic;    
		ttc_pads : INOUT ttc_pad;
		clk_pads : INOUT clk_pad;
		pci1_pads : INOUT lrb_pad;
		pci2_pads : INOUT lrb_pad;
		pci3_pads : INOUT pci3_pad;
		slink_pads : INOUT slink_pad;
		ram_pads : INOUT ram_pad;
		led_pads : INOUT led_pad;      
		lvds_pads : OUT lvds_pad
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset_dll :  std_logic := '0';

	--BiDirs
	SIGNAL ttc_pads :  ttc_pad;
	SIGNAL clk_pads :  clk_pad;
	SIGNAL pci1_pads :  lrb_pad;
	SIGNAL pci2_pads :  lrb_pad;
	SIGNAL pci3_pads :  pci3_pad;
	SIGNAL slink_pads :  slink_pad;
	SIGNAL ram_pads :  ram_pad;
	SIGNAL led_pads :  led_pad;

	--Outputs
	SIGNAL lvds_pads :  lvds_pad;
	signal cntr : std_logic_vector(15 downto 0) := x"0000";
signal ttcclk : std_logic := '0';
signal clk : std_logic := '0';
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: dcc PORT MAP(
		reset_dll => reset_dll,
		ttc_pads => ttc_pads,
		clk_pads => clk_pads,
		pci1_pads => pci1_pads,
		pci2_pads => pci2_pads,
		pci3_pads => pci3_pads,
		slink_pads => slink_pads,
		ram_pads => ram_pads,
		led_pads => led_pads,
		lvds_pads => lvds_pads
	);
clk <= not clk after 10ns;
clk_pads.ttc_clk <= ttcclk;
clk_pads.clk_in <= clk;
ttcclk <= not ttcclk after 13ns;
pci3_pads.data <= x"8000" when cntr = x"0045" else x"0001" when cntr = x"004a" else x"0000";
pci3_pads.ctrl(5 downto 3) <= "000";
pci3_pads.ctrl(2) <= '1' when cntr > x"0040" and cntr < x"0060" else '0';
pci3_pads.ctrl(1 downto 0) <= "10" when cntr = x"0045" or cntr = x"0046" else 
                              "11" when cntr = x"0049" or cntr = x"004a" else "00";
pci2_pads.ctrl(3 downto 0) <= "0000";
pci1_pads.ctrl(3 downto 0) <= "0000";
pci2_pads.data <= x"0000";
pci1_pads.data <= x"0000";
reset_dll <= '1' when cntr < x"0008" else '0';
ttc_pads.ttcready <= '1';
ttc_pads.brcststr1 <= '0';
ttc_pads.brcst(7 downto 3) <= "00000";
ttc_pads.sinerrstr <= '0';
ttc_pads.dberrstr <= '0';
ttc_pads.l1accept <= '0';
ttc_pads.bcntres <= '0';
ttc_pads.evcntres <= '0';
ttc_pads.sda <= 'H';
ttc_pads.scl <= 'H';
slink_pads.lffn <= '0';
slink_pads.ldownn <= '0';
led_pads.i <= '0';
process(clk)
begin
  if(clk'event and clk = '1')then
	 cntr <= cntr + 1;
  end if;
end process;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
