
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:17:31 08/09/2005
-- Design Name:   rnd_test
-- Module Name:   rnd_test_tb.vhd
-- Project Name:  dccv5
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: rnd_test
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY rnd_test_tb_vhd IS
END rnd_test_tb_vhd;

ARCHITECTURE behavior OF rnd_test_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT rnd_test
	PORT(
		clk : IN std_logic;
		strobe : IN std_logic;
		reset : IN std_logic;
		mem_test : IN std_logic;
		chk_done : IN std_logic;          
		ddr_w_gnt : IN std_logic;          
		mem_done : OUT std_logic;
		rd_blk : OUT std_logic;
		wr_blk : OUT std_logic;
		inc_pa : OUT std_logic
		);
	END COMPONENT;
	constant n : integer := 80;
	constant clk_period : time := 7.8 ns;
	SIGNAL cnt :  std_logic_vector(15 downto 0) := (others=>'0');
	SIGNAL sr :  std_logic_vector(n downto 0) := (others=>'0');

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL strobe :  std_logic := '0';
	SIGNAL reset :  std_logic := '1';
	SIGNAL mem_test :  std_logic := '0';
	SIGNAL chk_done :  std_logic := '0';
	SIGNAL ddr_w_gnt :  std_logic := '0';

	--Outputs
	SIGNAL mem_done :  std_logic;
	SIGNAL rd_blk :  std_logic;
	SIGNAL wr_blk :  std_logic;
	SIGNAL inc_pa :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: rnd_test PORT MAP(
		clk => clk,
		strobe => strobe,
		reset => reset,
		mem_test => mem_test,
		mem_done => mem_done,
		chk_done => chk_done,
		ddr_w_gnt => ddr_w_gnt,
		rd_blk => rd_blk,
		wr_blk => wr_blk,
		inc_pa => inc_pa
	);

   clk <= not clk after clk_period/2;
	process(clk)
	begin
	  if(clk'event and clk = '1')then
	    strobe <= not strobe;
	    if(cnt(15 downto 8) /= x"00" and cnt(7 downto 0) = x"00")then
	      ddr_w_gnt <= strobe;
	    else
	      ddr_w_gnt <= '0';
	    end if;
		 if(strobe = '1')then
	      cnt <= cnt + 1;
	      if(cnt = x"0010")then
	        reset <= '0';
			  mem_test <= '1';
			elsif(mem_done = '1')then
			  mem_test <= '0';
	      end if;
			sr <= sr(n-1 downto 0) & rd_blk;
			chk_done <= sr(n);
		 end if;
	  end if;
	end process;

END;
